// VCDemoDlg.cpp : implementation file
//

#include "stdafx.h"
#include "VCDemo.h"
#include "VCDemoDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CVCDemoDlg dialog

CVCDemoDlg::CVCDemoDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CVCDemoDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CVCDemoDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);

	init = 0;
}

void CVCDemoDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CVCDemoDlg)
	DDX_Control(pDX, IDC_ODOM1, ODOM1);
	DDX_Control(pDX, IDC_ODOM2, ODOM2);
	DDX_Control(pDX, IDC_ODOM3, ODOM3);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CVCDemoDlg, CDialog)
	//{{AFX_MSG_MAP(CVCDemoDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CVCDemoDlg message handlers

BOOL CVCDemoDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CVCDemoDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}

	if (!init) {
		init = 1;
		SetTimer(1000,1500,NULL);
		SetTimer(1010,50,NULL);
		SetTimer(1020,500,NULL);
		}

}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CVCDemoDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

BEGIN_EVENTSINK_MAP(CVCDemoDlg, CDialog)
    //{{AFX_EVENTSINK_MAP(CVCDemoDlg)
	ON_EVENT(CVCDemoDlg, IDC_ODOM1, -601 /* DblClick */, OnDblClickOdom1, VTS_NONE)
	ON_EVENT(CVCDemoDlg, IDC_ODOM2, -601 /* DblClick */, OnDblClickOdom2, VTS_NONE)
	ON_EVENT(CVCDemoDlg, IDC_ODOM3, -601 /* DblClick */, OnDblClickOdom3, VTS_NONE)
	//}}AFX_EVENTSINK_MAP
END_EVENTSINK_MAP()

BOOL CVCDemoDlg::DestroyWindow() 
{
	KillTimer(1000);
	KillTimer(1010);
	KillTimer(1020);
	
	return CDialog::DestroyWindow();
}

void CVCDemoDlg::OnTimer(UINT nIDEvent) 
{
	switch (nIDEvent) {
		case 1010: // fast timer
			ODOM2.SetValue(ODOM2.GetValue()+0.005);
			break;
		case 1020: // medium speed timer
			ODOM3.SetValue(ODOM3.GetValue()+0.05);
			break;
		case 1000: // slow timer
			ODOM1.SetValue(ODOM1.GetValue()+1.0);
			break;
		}

	CDialog::OnTimer(nIDEvent);
}

void CVCDemoDlg::OnDblClickOdom1() 
{
	ODOM1.ShowPropertyPage();
}

void CVCDemoDlg::OnDblClickOdom2() 
{
	ODOM2.ShowPropertyPage();
}

void CVCDemoDlg::OnDblClickOdom3() 
{
	ODOM2.ShowPropertyPage();
}
