VERSION 4.00
Begin VB.Form Form1 
   Caption         =   "Global Majic Software, Inc. - Odometer Examples"
   ClientHeight    =   4230
   ClientLeft      =   3015
   ClientTop       =   2550
   ClientWidth     =   6705
   Height          =   4920
   Icon            =   "OExample.frx":0000
   Left            =   2955
   LinkTopic       =   "Form1"
   ScaleHeight     =   4230
   ScaleWidth      =   6705
   Top             =   1920
   Width           =   6825
   Begin VB.Timer Timer3 
      Interval        =   500
      Left            =   2070
      Top             =   2970
   End
   Begin VB.Timer Timer2 
      Interval        =   50
      Left            =   3150
      Top             =   1860
   End
   Begin VB.Timer Timer1 
      Interval        =   1500
      Left            =   3360
      Top             =   690
   End
   Begin ODOMETERLib.Odometer Odometer3 
      Height          =   690
      Left            =   2610
      TabIndex        =   3
      Top             =   2790
      Width           =   3240
      _Version        =   65536
      _ExtentX        =   5715
      _ExtentY        =   1217
      _StockProps     =   4
      BeginProperty Font {0BE35203-8F91-11CE-9DE3-00AA004BB851} 
         name            =   "MS Sans Serif"
         charset         =   0
         weight          =   700
         size            =   18
         underline       =   0   'False
         italic          =   0   'False
         strikethrough   =   0   'False
      EndProperty
      DigitColor      =   8421504
      Digits          =   9
      ResetButton     =   -1  'True
      ResetPicture    =   "OExample.frx":030A
      WheelColor      =   8454143
   End
   Begin VB.Label Label1 
      Alignment       =   2  'Center
      Caption         =   "Double-Click on Odometer to Show Property Pages"
      BeginProperty Font 
         name            =   "MS Sans Serif"
         charset         =   0
         weight          =   400
         size            =   13.5
         underline       =   0   'False
         italic          =   0   'False
         strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H00FF0000&
      Height          =   465
      Left            =   30
      TabIndex        =   2
      Top             =   3690
      Width           =   6645
   End
   Begin ODOMETERLib.Odometer Odometer2 
      Height          =   540
      Left            =   3720
      TabIndex        =   1
      Top             =   1740
      Width           =   1365
      _Version        =   65536
      _ExtentX        =   2408
      _ExtentY        =   953
      _StockProps     =   4
      BorderWidth     =   7
      Decimals        =   2
      DigitColor      =   16711680
      Digits          =   9
      Value           =   998
   End
   Begin ODOMETERLib.Odometer Odometer1 
      Height          =   1380
      Left            =   3690
      TabIndex        =   0
      Top             =   180
      Width           =   2280
      _Version        =   65536
      _ExtentX        =   4022
      _ExtentY        =   2434
      _StockProps     =   4
      BeginProperty Font {0BE35203-8F91-11CE-9DE3-00AA004BB851} 
         name            =   "MS Sans Serif"
         charset         =   0
         weight          =   400
         size            =   13.5
         underline       =   0   'False
         italic          =   0   'False
         strikethrough   =   0   'False
      EndProperty
      BevelOuter      =   1
      BevelWidth      =   3
      BorderWidth     =   3
      Outline         =   -1  'True
      OutlineAlign    =   2
      OutlineColor    =   255
      OutlineTitle    =   "Web Hits"
      OutlineWidth    =   8
      Decimals        =   0
      DigitColor      =   8388608
      Digits          =   7
      Value           =   992
      WheelColor      =   16776960
   End
   Begin VB.Menu mnu 
      Caption         =   "&Order"
      Index           =   0
   End
   Begin VB.Menu mnu 
      Caption         =   "&Help"
      Index           =   1
      Begin VB.Menu helpmnu 
         Caption         =   "&About Odometer"
         Index           =   0
      End
      Begin VB.Menu helpmnu 
         Caption         =   "&Odometer Help"
         Index           =   1
      End
      Begin VB.Menu helpmnu 
         Caption         =   "&Instrument ActiveX Library Help"
         Index           =   2
      End
   End
   Begin VB.Menu mnu 
      Caption         =   "E&xit"
      Index           =   2
   End
End
Attribute VB_Name = "Form1"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
Private Sub Form_Load()

    'Center on page
    Left = (Screen.Width - Width) / 2
    Top = (Screen.Height - Height) / 2

    About.Show 1
    
    Odometer1.Value = 982
    Odometer2.Value = 9996
    Odometer3.Value = 99996
    
End Sub

Private Sub helpmnu_Click(Index As Integer)
    
    Select Case Index
        Case 0 'About Odometer
            About.Show 1
        Case 1 'Odometer Help
            i = Shell("winhlp32 odom30.hlp", 1)
        Case 2 'IAL Help
            i = Shell("winhlp32 products.hlp", 1)
    End Select

End Sub

Private Sub mnu_Click(Index As Integer)

    Select Case Index
        Case 0 'Order
            i = Shell("winhlp32 order.hlp", 1)
        Case 1 'Help
        Case 2 'Exit
            End
    End Select
    
End Sub


Private Sub Odometer1_DblClick()

    Odometer1.ShowPropertyPage
    
End Sub

Private Sub Odometer2_DblClick()

    Odometer2.ShowPropertyPage
    
End Sub

Private Sub Odometer3_DblClick()

    Odometer3.ShowPropertyPage
    
End Sub

Private Sub Timer1_Timer()

    Odometer1.Value = Odometer1.Value + 1
    
End Sub


Private Sub Timer2_Timer()

    Odometer2.Value = Odometer2.Value + 0.005
    
End Sub


Private Sub Timer3_Timer()

    Odometer3.Value = Odometer3.Value + 0.05
    
End Sub


